SHEBANG
# Copyright @GD (C)2005
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon.m4,v 1.1 2005/04/06 14:56:14 gd Exp $

JNTROSTUP(smsgate,,dnl
,dnl
# jailup smsgate dir dev cuaa
#           dir relative to ${JAILUPDIR}
#           dev - one of jailup devfull devices
#           cuaa - com port where modem installed (cuaa0 | cuaa1)
# installed jailup qmail, jailup sh and ports/comms/scmxx
#						useddnl
)

this="${UPLIBDIR}/${genclass}"
jdir="${1}"
dev="${2:-vn7sXx}"
cuaa="${3:-cuaa1}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

mount=/sbin/mount
umount=/sbin/umount

${mkdir} "${main_dir}"
${up_mdir} "${main_dir}" ${MTREE}

${up_shlib} "${main_dir}/usr/lib" << "EOF"
    c gnugetopt gnuregex iconv /usr/local/lib/libintl.so.6 z
EOF
    
${up_libexe} "${main_dir}/usr/libexec" << EOF
    ld-elf.so.1
EOF

${up_exec} "${main_dir}/bin" << EOF
    ripmime
    scmxx
    ${this}/smsit.sh
EOF

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_ponf} "${conf_dir}/smsit.conf" << EOF
TMPDIR=Maildir/tmp
PID=${TMPDIR}/smsit.pid
COM=/dev/${cuaa}
EOF

#${mv} "${conf_dir}/group" "${conf_dir}/group.old"

${up_ponf} "${conf_dir}/group" << "EOF"
uucp:*:66:
dialer:*:68:
EOF

#${mv} "${conf_dir}/master.passwd" "${conf_dir}/master.passwd.old"

${up_ponf} "${conf_dir}/master.passwd" << "EOF"
uucp:*:66:66::0:0::/home/uucp:/nonexistent
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"
${up_ponf} "${main_dir}/home/uucp/.qmail" << "EOF"
| preline /bin/smsit.sh
EOF

${up_mtree} "${main_dir}" ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.                       type=dir mode=0755
    group
    master.passwd       mode=0600
..
EOF

      #####################################
      ####                             ####
      ####  Begin prepare cuua device  ####
      ####                             ####
${mount} /dev/${dev} ${main_dir}/dev
${rm} -rf ${main_dir}/dev/ptyp*
${rm} -rf ${main_dir}/dev/ttyp*
${rm} -rf ${main_dir}/dev/fd
cd ${main_dir}/dev
${ln} -fs /dev/MAKEDEV
./MAKEDEV ${cuaa}
${rm} MAKEDEV
cd ${TMPDIR:-/tmp}
${umount} ${main_dir}/dev
      ####                             ####
      #### End of prepare cuua device  ####
      ####                             ####
      #####################################

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} "${etcdir}/fstab" | ${grep} -v "${main_dir}/dev" > "${etcdir}/fstab"
${cat} << EOF >> "${etcdir}/fstab"
#/dev/${dev}            ${main_dir}/dev ufs     rw,noexec,noauto 0 0
EOF

echo "#${mount} \"${main_dir}/dev\"" >> "${etcdir}/rc.local"

      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
