#!/bin/sh
# Copyright @GD (C)2005
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: smsit.sh,v 1.1 2005/04/06 14:56:14 gd Exp $

CONF=/etc/smsit.conf

. ${CONF}

mktemp=/bin/mktemp
cat=/bin/cat
ripmime=/bin/ripmime
basename=/bin/basename
mv=/bin/mv
head=/bin/head
tail=/bin/tail
rm=/bin/rm
scmxx=/bin/scmxx
grep=/bin/grep
find=/bin/find
tr=/bin/tr
date=/bin/date
echo=/bin/echo

TMPDIR="${TMPDIR:-Maildir/tmp}"
PID="${PID:-Maildir/tmp/smsit.pid}"
COM="${COM:-/dev/cuaa1}"

if [ -z "${1}" ] #    stdin
then
    #    
    now=`${date} "+%Y.%m.%d_%H:%M:%S"`
    curfile="`${mktemp} Maildir/new/smsgate.${now}.XXXXXXXX`"
    ${cat} - > "${curfile}"
else #    
    curfile="${1}"
fi

if [ -f "${curfile}" ] #    ?
then
    if [ -f "${PID}" ] #       
    then
        #   ,    
        exit
    else
        #    -    
        ${echo} $$ > ${PID}
    fi

    curname="`${basename} ${curfile}`"
    
    #     
    ${mv} "${curfile}" "${TMPDIR}/${curname}"
    
    #  
    ${ripmime} -i "${TMPDIR}/${curname}" -d "${TMPDIR}/${curname}_out"

    #      
    phone="`${head} -1 ${TMPDIR}/${curname}_out/textfile0 | \
            ${tr} -c -d '+1234567890'`" #    +  
    #  , 
    mess="`${head} -2 ${TMPDIR}/${curname}_out/textfile0 | \
            ${tail} -1 | \
            ${head} -c 160`" #    160 

    #  
    rm -rf "${TMPDIR}/${curname}_out"

    #  SMS
    result=`${scmxx} -d ${COM} -s -S \
                --direct -n ${phone} -t "${mess}" 2>&1 | \
            ${grep} 'message was sent'` #  , 
                            #  

    if [ -z "${result}" ]
    then
        #  ,    
        #   
        ${mv} "${TMPDIR}/${curname}" "${curfile}"
    else
        #   
        #   
        ${rm} -rf "${TMPDIR}/${curname}"
    fi
    
    # , PID 
    ${rm} -rf "${PID}"

    #         ?
    newfile="`${find} Maildir -type f | ${head} -1`"
    
    if [ ! -z "${newfile}" ]
    then
        #  , 
        #    
        ${0} ${newfile} &
    fi
fi
